//+------------------------------------------------------------------+
//|                                                     MTF_RSI.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
#property indicator_color3 Aqua //Red
#property indicator_width3 3
#property indicator_color4 Magenta //Red
#property indicator_width4 3
#property indicator_color5 DodgerBlue
#property indicator_width5 5
#property indicator_color6 Red
#property indicator_width6 5

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/

extern int  TimeFrame     = 0;
extern int  FastCCI       = 7;
extern bool UseFCCIArrow  = true;
extern int  SlowCCI       = 21;
extern bool UseSCCIArrow  = true;
extern int  VerySlowCCI   = 50;
extern bool UseVSCCIArrow = false;
extern bool ShowAlert     = true;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
   
bool   AlertBuy1  = false;
bool   AlertSell1 = false;
bool   AlertBuy2  = false;
bool   AlertSell2 = false;
bool   AlertBuy3  = false;
bool   AlertSell3 = false;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID, 2);//2
   SetIndexArrow(0,93);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID, 2);//2
   SetIndexArrow(1,93);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW,STYLE_SOLID, 2);
   SetIndexArrow(2,111);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,111);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,241);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,242);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
//----

//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("MTF_CCI_Cross");
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF RSI                                            |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int  i,limit,y=0,counted_bars=IndicatorCounted();
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
   
  
        ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,0,y); 
        ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,1,y); 
        ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,2,y); 
        ExtMapBuffer4[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,3,y); 
        ExtMapBuffer5[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,4,y); 
        ExtMapBuffer6[i]=iCustom(NULL,TimeFrame,"CCI Cross",FastCCI,UseFCCIArrow,SlowCCI,UseSCCIArrow,VerySlowCCI,UseVSCCIArrow,ShowAlert,5,y);    
   
   }  
     
//
   
  //FIX for display
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (TimeFrame>Period()) {
     int PerINT=TimeFrame/Period()+1;
     datetime TimeArr[]; ArrayResize(TimeArr,PerINT);
     ArrayCopySeries(TimeArr,MODE_TIME,Symbol(),Period()); 
     for(i=0;i<PerINT+1;i++) {if (TimeArr[i]>=TimeArray[0]) {
//----
 /************************************************ by Raff   
    Refresh buffers:         buffer[i] = buffer[0];
 ********************************************************/  

   ExtMapBuffer1[i]= ExtMapBuffer1[0];
   ExtMapBuffer2[i]= ExtMapBuffer2[0];
   ExtMapBuffer3[i]= ExtMapBuffer3[0];
   ExtMapBuffer4[i]= ExtMapBuffer4[0];
   ExtMapBuffer5[i]= ExtMapBuffer5[0];
   ExtMapBuffer6[i]= ExtMapBuffer6[0];
   ExtMapBuffer1[y]= ExtMapBuffer1[0];
   ExtMapBuffer2[y]= ExtMapBuffer2[0];
   ExtMapBuffer3[y]= ExtMapBuffer3[0];
   ExtMapBuffer4[y]= ExtMapBuffer4[0];
   ExtMapBuffer5[y]= ExtMapBuffer5[0];
   ExtMapBuffer6[y]= ExtMapBuffer6[0];
   
//----
   } } }
//+++++++++++++++++++++++++++++++++++++++++++++++++++
//END of fix
  
   return(0);
  }
//+------------------------------------------------------------------+